Go中的错误和异常处理最佳实践

本文已收录​​编程学习笔记​​。涵盖PHP、JavaScript、Linux、Golang、MySQL、Redis和开源工具等等相关内容。

错误

认识错误

在Go中,错误是一种表示程序错误状态。包含了在程序在运行时、编译时的状态信息。一般我们在编写Go代码中,都会碰到如下的处理方式。

file, err := os.Create("test.txt")

fmt.Println(file)

if err != nil {
fmt.Println(err)
return
}

我们使用os库创建一个名为test.txt的文件,该方法返回一个文件指针或err的错误信息。

err表示文件创建失败时的错误信息。当存储错误时,我们则对程序做错误处理;不存在错误时,则正常执行其他的逻辑代码。

自定义错误

在Go中是允许我们自定义错误信息的。自定义错误信息需要利用自带的error报中的New()函数。如下示例代码:

package main

import (
"errors"
"fmt"
)

func printError() (a int, err error) {
err = errors.New("打印错误信息")
a = 1
return
}

func main() {
i, err := printError()
fmt.Println("i value is", i)
if err != nil {
fmt.Println(err)
return
}
}

具体的打印信息:​​i value is 1 打印错误信息​​。

实现原理

在使用​​errors.New()​​函数时,该包中声明了一个结构体​​errorString​​并且实现了error接口体中的方法​​Error()​​。

// errors包
package errors

func New(text string) error {
return &errorString{text}
}

type errorString struct {
s string
}

func (e *errorString) Error() string {
return e.s
}
// error接口
type error interface {
Error() string
}

异常

认识异常

异常是程序在​​编译时​​或者​​运行时​​发生的异常信息。如果不对异常做处理,可能导致程序终止程序或者抛出异常信息,导致程序无法正常运行。不管是在程序编译或者运行时,都需要对异常进行严格处理。如下代码,程序在编译时就会触发异常,导致无法进行正常编译:

package main

import "fmt"

func main() {
panic("print panic")
fmt.Println("end")
}

打印结果

╰─ go run demo6.go 
panic: print panic

goroutine 1 [running]:
main.main()
/usr/local/var/www/go/golang_code/src/syntax/err/demo6.go:20 +0x39
exit status 2
  1. Go 运行时会触发运行时 panic,伴随着程序的崩溃抛出一个 runtime.Error 接口类型的值。这个错误值有个 RuntimeError() 方法用于区别普通错误。
  2. panic 可以直接从代码初始化:当错误条件(我们所测试的代码)很严苛且不可恢复,程序不能继续运行时,可以使用 panic 函数产生一个中止程序的运行时错误。
  3. panic 接收一个做任意类型的参数,通常是字符串,在程序死亡时被打印出来。Go 运行时负责中止程序并给出调试信息。
  4. 在多层嵌套的函数调用中调用 panic,可以马上中止当前函数的执行。

处理异常

当程序在运行过程中发生异常,会终止程序的正常运行。需要严格处理异常信息。Go中可以使用recover()将程序从panic中获取异常信息,并获取程序的执行权。

  1. 正如名字一样,这个(recover)内建函数被用于从 panic 或 错误场景中恢复:让程序可以从 panicking 重新获得控制权,停止终止过程进而恢复正常执行。
  2. recover只能在defer修饰的函数中使用:用于取得panic调用中传递过来的错误值,如果是正常执行,调用recover会返回 nil,且没有其它效果。
  3. panic 会导致栈被展开直到defer修饰的recover()被调用或者程序中止。
  4. 所有的 defer 语句都会保证执行并把控制权交还给接收到 panic 的函数调用者。这样向上冒泡直到最顶层,并执行(每层的) defer,在栈顶处程序崩溃,并在命令行中用传给 panic 的值报告错误情况:这个终止过程就是 panicking。

异常处理原则

  1. 在包内部,应该从panic中recover:不允许显式的超出包范围的panic()。在包内部,特别是在非导出函数中有很深层次的嵌套调用时,对主调函数来说用 panic 来表示应该被翻译成错误的错误场景是很有用的(并且提高了代码可读性)。
  2. 在包外部,向包的调用者返回错误值(而不是panic)。
  3. Go 库的原则是即使在包的内部使用了 panic,在它的对外接口(API)中也必须用 recover 处理成返回显式的错误。

异常处理实践

下面的示例代码,在被调用函数printPanic()中触发一个panic(),在main()函数中使用defer中接收panic()信息,并对panic()做异常处理。

package main

import "fmt"

func printPanic() {
panic("panic exception")
}

func main() {
defer func() {
err := recover()
if err != nil {
fmt.Println("panic is", err)
}
}()

printPanic()

fmt.Println("end")
}
╰─ go run demo5.go
i value is 1
打印错误信息
发表评论

相关文章